package no.statnett.ecp.md;

import no.statnett.ecp.utils.EcpHTTP;

import java.io.IOException;
import java.net.URL;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;

public class BAMessageDelays {
  public static final String VERSION = "0.1.0";

  private static String user;
  private static String pw;
  private static URL url;


  public static void main(String[] args) throws IOException, NoSuchAlgorithmException, KeyManagementException {
    URL initialURL = new URL(args[0]);
    url = new URL(initialURL.getProtocol(), initialURL.getHost(), initialURL.getPort(), "/api/rest/messages/delayed/page/0?count=10&filter=green&getMessages=true&orderBy=time&orderDir=asc&range=20");
    if (initialURL.getUserInfo() != null) {
      user = initialURL.getUserInfo().split(":")[0];
      pw = initialURL.getUserInfo().split(":")[1];
    }
    String response = EcpHTTP.getECPHTTResponse("GET", url, user, pw, null);
    // the response is something like this, max 1000 items covering the last 24 hours, probably the 1000 latest messages:
    // {"items":[
    //   {"id":339320,
    //   "status":"Received",
    //   "time":"2024-11-01T14:41:03.35787923",
    //   "direction":"Send",
    //   "sender":"50V-SN-TEST--ATK",
    //   "senderName":"Statnett",
    //   "receiver":"50V-SN-TEST2-AT7",
    //   "receiverName":"Statnett",
    //   "messageType":"TEST",
    //   "edxKind":"PLAIN",
    //   "baMessageId":null,
    //   "baCorrelationId":null,
    //   "senderApplication":"MORTEN",
    //   "signal":"green"}
    // ],"itemsCount":1,"pageNum":0,"pageSize":10,"allCount":1,"orangeCount":0,"redCount":0}
    // There could be many items in the items array

    // We're interested in the following:
    // * Only status !=m Received
    // * Only direction = Send
    // * time
    // * receiver
    // * receiverName

    // From these we can make a list like this:
    // receiver/receiverName: last time with delay, number of delays last 24h
    // total: last time with delay, number of delays last 24h

    // Find the oldest "last time" and ask for all messages since that time (filter is not set at all). For each receiver that had delays, find newest
    // message. Compare if this newest message is newer than the "last time" (if so, the status of that message is OK)

    // Hmmm, dette kan koste mye ressurser...  montro om edx-ml-log er veien å gå...)






    System.out.println(response);
  }

  private static void usage() {
    System.out.println("MessageDelay v" + VERSION + " lists messages that has been delayed as seen from EDX.");
    System.out.println();
    System.out.println("Usage  : java -jar ekit.jar MD <EDX-URL>\n");
    System.out.println("\n\nThe arguments:");
    System.out.println(" OPTIONS      ");
    System.out.println("     -m <METHOD>   : GET, POST, PUT (Default is GET)");
    System.out.println("     -b <BODY>     : Body of the request (only for POST and PUT) (Default is null/empty)");
    System.out.println("MANDATORY ARGUMENTS");
    System.out.println("     <ECP-URL>     : Specify url on this form: http[s]://user:pass@host:port");
    System.out.println();
    System.out.println("\nExample 1:  Run connectivity check towards two endpoint from your localhost-endoint");
    System.out.println("\tjava -jar ekit.jar MD https://admin:password@remote-host:9443");
  }

}
